#ifndef _GTA01_H
#define _GTA01_H

#include <asm/arch/regs-gpio.h>
#include <asm/arch/irqs.h>

/* Different hardware revisions, passed in ATAG_REVISION by u-boot */
#define GTA01v3_SYSTEM_REV	0x00000130
#define GTA01v4_SYSTEM_REV	0x00000140
#define GTA01Bv2_SYSTEM_REV	0x00000220
#define GTA01Bv3_SYSTEM_REV	0x00000230
#define GTA01Bv4_SYSTEM_REV	0x00000240

/* Backlight */

extern void gta01bl_deferred_resume(void);

struct gta01bl_machinfo {
	unsigned int default_intensity;
	unsigned int max_intensity;
	unsigned int limit_mask;
	unsigned int defer_resume_backlight;
};

/* Definitions common to all revisions */
#define GTA01_GPIO_BACKLIGHT	S3C2410_GPB0
#define GTA01_GPIO_GPS_PWRON	S3C2410_GPB1
#define GTA01_GPIO_MODEM_RST	S3C2410_GPB6
#define GTA01_GPIO_MODEM_ON	S3C2410_GPB7
#define GTA01_GPIO_LCD_RESET	S3C2410_GPC6
#define GTA01_GPIO_PMU_IRQ	S3C2410_GPG8
#define GTA01_GPIO_JACK_INSERT	S3C2410_GPF4
#define GTA01_GPIO_nSD_DETECT	S3C2410_GPF5
#define GTA01_GPIO_AUX_KEY	S3C2410_GPF6
#define GTA01_GPIO_HOLD_KEY	S3C2410_GPF7
#define GTA01_GPIO_VIBRATOR_ON	S3C2410_GPG11

#define GTA01_IRQ_MODEM		IRQ_EINT1
#define GTA01_IRQ_JACK_INSERT	IRQ_EINT4
#define GTA01_IRQ_nSD_DETECT	IRQ_EINT5
#define GTA01_IRQ_AUX_KEY	IRQ_EINT6
#define GTA01_IRQ_PCF50606      IRQ_EINT16

/* GTA01v3 */
#define GTA01v3_GPIO_nGSM_EN	S3C2410_GPG9

/* GTA01v4 */
#define GTA01_GPIO_MODEM_DNLOAD	S3C2410_GPG0

/* GTA01Bv2 */
#define GTA01Bv2_GPIO_nGSM_EN	S3C2410_GPF2
#define GTA01Bv2_GPIO_VIBRATOR_ON S3C2410_GPB10

/* GTA01Bv3 */
#define GTA01_GPIO_GPS_EN_3V3	S3C2410_GPG9

#define GTA01_GPIO_SDMMC_ON	S3C2410_GPB2
#define GTA01_GPIO_BT_EN	S3C2410_GPB5
#define GTA01_GPIO_AB_DETECT	S3C2410_GPB8
#define GTA01_GPIO_USB_PULLUP	S3C2410_GPB9
#define GTA01_GPIO_USB_ATTACH	S3C2410_GPB10

#define GTA01_GPIO_GPS_EN_2V8	S3C2410_GPG9
#define GTA01_GPIO_GPS_EN_3V	S3C2410_GPG10
#define GTA01_GPIO_GPS_RESET	S3C2410_GPC0

/* GTA01Bv4 */
#define GTA01Bv4_GPIO_nNAND_WP	S3C2410_GPA16
#define GTA01Bv4_GPIO_VIBRATOR_ON S3C2410_GPB3
#define GTA01Bv4_GPIO_PMU_IRQ	S3C2410_GPG1

#define GTA01Bv4_IRQ_PCF50606	IRQ_EINT9

#endif /* _GTA01_H */
